using System.Collections.Generic;
using System;

namespace WingServerCommon.Config
{    
   public class StorageSettings
    {
        /// <summary>
        /// 默认云存储服务
        /// </summary>
        public StorageServerEnum DefaultStorageServer { get; set; }

        /// <summary>
        /// 云存储服务分配的 用户id
        /// </summary>
        public string AppId { get; set; }=string.Empty;

        /// <summary>
        /// 秘钥
        /// </summary>
        public string Sercret { get; set; }=string.Empty;

        /// <summary>
        /// 存储服务
        /// </summary>
        public string CFSServerUrl { get; set; }=string.Empty;

        /// <summary>
        /// cdn服务
        /// </summary>
        public string CDNServerUrl { get; set; }=string.Empty;
    }

    /// <summary>
    /// Storage 服务类型
    /// </summary>
    public enum StorageServerEnum
    {
        //自建云服务
        Vinno,
        //腾讯云服务
        Tencent
    }

}