using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WingServerCommon.Interfaces.Cache
{
    /// <summary>
    /// 设备调参数据缓存
    /// </summary>
    public interface IControllingParametersManager : IBaseCacheManager<CacheControllingParameter>
    {

    }
    public class ControllingParametersManager : CacheManager<CacheControllingParameter>, IControllingParametersManager
    {
        public ControllingParametersManager() : base()
        {
        }
    }
    public class CacheControllingParameter : ICacheObject
    {
        public CacheControllingParameter()
        {

        }
        /// <summary>
        /// 设备编码
        /// </summary>
        /// <value></value>
        public string Code { get; set; }
        /// <summary>
        /// 探头应用信息
        /// </summary>
        /// <value></value>
        public string ProbeApplication { get; set; }
        /// <summary>
        /// 设备参数
        /// </summary>
        /// <value></value>
        public string Parameter { get; set; }
    }

}