using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WingServerCommon.Interfaces.Cache
{
    /// <summary>
    /// 等保配置管理
    /// </summary>
    public interface IGradingProtectionConfigManager : IBaseCacheManager<CacheGradingProtectionConfigDTO>
    {

    }
    public class GradingProtectionConfigManager : CacheManager<CacheGradingProtectionConfigDTO>, IGradingProtectionConfigManager
    {
        public GradingProtectionConfigManager() : base()
        {
        }
    }

    /// <summary>
    /// 配置缓存
    /// </summary>
    public class CacheGradingProtectionConfigDTO : ICacheObject
    {
        /// <summary>
        ///模块配置编码
        /// </summary>
        public string Code { get; set; } = string.Empty;
        /// <summary>
        /// 模块名称
        /// </summary>
        /// <value></value>
        public string Name { get; set; }
        
        /// 等保配置类型
        /// </summary>
        /// <value></value>
        public int ConfigType { get; set; }

        /// <summary>
        /// 配置值
        /// </summary>
        public string Value { get; set; }
    }
}