using System;
using WingServerCommon.Log;
using WingServerCommon.Interfaces.OpLog;
namespace WingServerCommon.Interfaces.Cache
{
    public interface IReportPostersManager : IBaseCacheManager<CacheReportPostersDTO>
    {

    }

    public class ReportPostersManager : CacheManager<CacheReportPostersDTO>, IReportPostersManager
    {
        public ReportPostersManager() : base()
        {
        }
    }

    public class CacheReportPostersDTO : ICacheObject
    {
        /// <summary>
        /// 报告转发配置编码
        /// </summary>
        public string Code { get; set; } = string.Empty;
        /// <summary>
        /// Receiver customer name
        /// </summary>
        /// <value></value>
        public string ReceiverName { get; set; }
        /// <summary>
        /// The contact name
        /// </summary>
        /// <value></value>
        public string Contact { get; set; }
        /// <summary>
        /// The contact's phone
        /// </summary>
        /// <value></value>
        public string Phone { get; set; }
        /// <summary>
        /// Target url
        /// </summary>
        /// <value></value>
        public string TargetUrl { get; set; }
        /// <summary>
        /// Template
        /// </summary>
        /// <value></value>
        public string Template { get; set; }
        /// <summary>
        /// The report format
        /// </summary>
        /// <value></value>
        public int PosterType { get; set; }
        /// <summary>
        /// The report format
        /// </summary>
        /// <value></value>
        public int ReportFormat { get; set; }
        /// <summary>
        /// The post action timeout, unit is second
        /// </summary>
        /// <value></value>
        public int PostTimeout { get; set; }
        /// <summary>
        /// Device ids
        /// </summary>
        /// <value></value>
        public List<string> DeviceIds { get; set; } = new List<string>();
    }
}