using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using WingServerCommon.Interfaces.Cache;

namespace WingServerCommon.Interfaces.Login
{
    /// <summary>
    /// 登录锁定管理类
    /// </summary>
    public class AdminLoginLock : LoginLock
    {

        public AdminLoginLock(int loginLockTimes) : base(loginLockTimes)
        {
        }

        /// <summary>
        /// 检查返回登录错误信息方法
        /// </summary>
        /// <param name="loginDate"></param>
        /// <param name="times"></param>
        /// <returns>>true: 登录锁定</returns>
        public LoginLockResult CheckUserLoginLocked(string code,DateTime loginDate, int times)
        {
            return CheckLoginIsLocked(code,loginDate, times);
        }
        /// <summary>
        /// 获取是否账号已锁定
        /// </summary>
        /// <param name="lastLoginDate"></param>
        /// <param name="lastLoginTimes"></param>
        /// <returns></returns>
        public   bool GetAdminLoginIsLocked(DateTime lastLoginDate, int lastLoginTimes)
        {
            return  base.GetLoginIsLocked(lastLoginDate,lastLoginTimes);
        }
    }
}