using System;
namespace WingServerCommon.Interfaces.OpLog
{
    public class DatabaseCollection
    {
        /// <summary>
        /// Database Collection Changed (for db write operation)
        /// </summary>
        public static event EventHandler<CollectionDocumentChangedArgs> CollectionDocumentChanged;

        /// <summary>
        /// Raise the collection dicument changed event
        /// </summary>
        /// <param name="args"></param>
        public static void RaiseCollectionDocumentChanged(CollectionDocumentChangedArgs args)
        {
            CollectionDocumentChanged?.Invoke(null, args);
        }
    }

    public class CollectionDocumentChangedArgs : EventArgs
    {
        /// <summary>
        /// The changed collection name
        /// </summary>
        /// <value></value>
        public string CollectionName {get;set;} = string.Empty;
          
        /// <summary>
        /// The unique document ids
        /// </summary>
        /// <value></value>
        public string[] DocumentIds {get;set;}
    }
}